#pragma once

#include "afxtempl.h"

// CNgramNode command target

class CNgramNode : public CObject
{
public:
	CNgramNode(const CString &word, UINT count = 0);
	virtual ~CNgramNode();

	// accessors
	CString *getWord() {return &m_word;}
	UINT getCount() {return m_count;}
	CNgramNode *getChild(const CString &word);
	CList<CNgramNode*>* getChildren() {return &m_children;}

	// mutators
	void setWord(const CString &word);
	void incCount() {m_count++;}
	CNgramNode *addChild(const CString &word);
	

private:
	CString m_word;
	UINT m_count;
	CList<CNgramNode*> m_children;
public:
	virtual void Serialize(CArchive& ar);
};


