// NgramWordPredictorView.h : interface of the CNgramWordPredictorView class
//


#pragma once

class CNgramNode;

#include "afxtempl.h"

class CNgramWordPredictorView : public CView
{
protected: // create from serialization only
	CNgramWordPredictorView();
	DECLARE_DYNCREATE(CNgramWordPredictorView)

// Attributes
public:
	CNgramWordPredictorDoc* GetDocument() const;

private:
	CDialogNgram *m_pinputDialog;

// Operations
public:
	CDialogNgram *getInputDialog() {return m_pinputDialog;}

private:
	void displayModel(CDC *pDc, CNgramNode *pnode, int level, CArray<bool> *drawVertBar);

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// Implementation
public:
	virtual ~CNgramWordPredictorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnBnClickedLearnButton();
protected:

public:
	afx_msg void OnViewInputdialog();
};

#ifndef _DEBUG  // debug version in NgramWordPredictorView.cpp
inline CNgramWordPredictorDoc* CNgramWordPredictorView::GetDocument() const
   { return reinterpret_cast<CNgramWordPredictorDoc*>(m_pDocument); }
#endif

